Bug 1242239 - md raid1 writemostly feature broken
Summary: md raid1 writemostly feature broken
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: kernel
Version: 6.6
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: rc
: ---
Assignee: Jes Sorensen
QA Contact: Zhang Yi
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: 1270066
TreeView+ depends on / blocked
 
Reported: 2015-07-12 13:25 UTC by Dwight (Bud) Brown
Modified: 2016-05-10 22:51 UTC (History)
5 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2016-05-10 22:51:23 UTC


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2016:0855 normal SHIPPED_LIVE Moderate: kernel security, bug fix, and enhancement update 2016-05-10 22:43:57 UTC

Description Dwight (Bud) Brown 2015-07-12 13:25:00 UTC
Description of problem:

Customer encountered mdraid broken writemostly feature - both disks in mirror are read from fairly equally even with writemostly set on just one leg.

writemostly feature broken by upsteam commit:
http://git.kernel.org/cgit/linux/kernel/git/torvalds/linux.git/commit/drivers/md/raid1.c?id=9dedf60313fa4dddfd5b9b226a0ef12a512bf9dc

fixed by upstream commit:
http://git.kernel.org/cgit/linux/kernel/git/torvalds/linux.git/commit/drivers/md?id=d1901ef099c38afd11add4cfb3312c02ef21ec4a

"
md/raid1: fix read balance when a drive is write-mostly.
When a drive is marked write-mostly it should only be the
target of reads if there is no other option.

This behaviour was broken by

commit 9dedf60313fa4dddfd5b9b226a0ef12a512bf9dc
    md/raid1: read balance chooses idlest disk for SSD

which causes a write-mostly device to be *preferred* is some cases.
"




Version-Release number of selected component (if applicable):


How reproducible:
100%

Steps to Reproduce:
1. create mirror
2. set writeonly on one leg
3. perform reads.

Actual results:
reads from both legs of mirror

Expected results:
reads avoided on leg of mirror marked writeonly

Additional info:

Comment 5 Aristeu Rozanski 2015-11-04 20:44:21 UTC
Patch(es) available on kernel-2.6.32-584.el6

Comment 8 Zhang Yi 2016-01-28 13:59:48 UTC
Verified on kernel-2.6.32-584.el6:
I used two disks: sdb/sdc for test, after set one disk: sdc with writemostly, the MB_read of iostat for sdc becomes 0.

The patch from commet 6 also exist on 2.6.32-584.el6.

Change to verified.

Comment 10 errata-xmlrpc 2016-05-10 22:51:23 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2016-0855.html


Note You need to log in before you can comment on or make changes to this bug.